<?php
// AddUsers - Allows you to add/remove users
function AddUsers() {
  global $Messages,$uname,$lvl,$scripturl,$nphpConfig,$version,$mydetails,$nphpUsers;
  htmlHeader($Messages["Sections_EditUsers"]);

  print("<table border=0>\n");
  print("<form method=post action=\"$scripturl?saveadduser\">\n");
  print("<tr><td align=right>\n");
  print("&nbsp;");
  print("</td><td align=left>\n");
  print("<b>" . $Messages["EditUsers_AddaUser"] . "</b>\n");
  print("</td></tr>\n");

  print("<tr><td align=right>\n");
  print("<b>" . $Messages["UserName"] . ":</b>");
  print("</td><td align=left>\n");
  print("<input type=text name=add_username size=25>\n");
  print("</td></tr>\n");

  print("<tr><td align=right>\n");
  print("<b>" . $Messages["Password"] . ":</b>");
  print("</td><td align=left>\n");
  print("<input type=password name=add_password size=25>\n");
  print("</td></tr>\n");

  print("<tr><td align=right>\n");
  print("<b>" . $Messages["Email"] . ":</b>");
  print("</td><td align=left>\n");
  print("<input type=text name=add_email size=25>\n");
  print("</td></tr>\n");

  print("<tr><td align=right>\n");
  print("<b>" . $Messages["Level"] . ":</b>");
  print("</td><td align=left>\n");
  print("<select name=add_level>\n");
  print("<option value=\"1\">" . $Messages["EditUsers_Lvl1"] . "</option>");
  print("<option value=\"2\">" . $Messages["EditUsers_Lvl2"] . "</option>");
  print("<option value=\"3\">" . $Messages["EditUsers_Lvl3"] . "</option>");
  print("</select>");
  print("</td></tr>\n");

  print("<tr><td align=right>\n");
  print("&nbsp;");
  print("</td><td align=left>\n");
  print("<input type=submit value=" . $Messages["Submit"] . "></form>\n");
  print("</td></tr>\n");

  print("<form method=post action=\"$scripturl?saveremoveuser\">\n");
  print("<tr><td align=right>\n");
  print("&nbsp;");
  print("</td><td align=left>\n");
  print("&nbsp;\n");
  print("</td></tr>\n");

  print("<tr><td align=right>\n");
  print("&nbsp;");
  print("</td><td align=left>\n");
  print("<b>" . $Messages["EditUsers_RemoveaUser"] . "</b>\n");
  print("</td></tr>\n");

  print("<tr><td align=right>\n");
  print("<b>" . $Messages["UserName"] . ":</b>");
  print("</td><td align=left>\n");
  print("<select name=remove_username>\n");

  for($i=0;$i<count($nphpUsers);$i++)
  {
   print("<option value=\"" . $nphpUsers[$i][0] . "\">" . $nphpUsers[$i][0] . "</option>");
  }

  print("</select>");
  print("</td></tr>\n");

  print("<tr><td align=right>\n");
  print("&nbsp;");
  print("</td><td align=left>\n");
  print("<input type=submit value=" . $Messages["Submit"] . "></form>\n");
  print("</td></tr>\n");

  print("</table>\n");
  print("</form>\n");

  htmlFooter();
}

// LanguageSelect - Select a language
function LanguageSelect() {
  global $Messages,$uname,$lvl,$scripturl,$nphpConfig,$version,$mydetails,$LangsData,$LangName;
  print($Messages["Language_Text"] . "<BR>");
  print("<form method=\"post\" action=\"$scripturl?langssave\">\n");
  print("<table border=0><tr><td align=right>");
  print($Messages["Language"] . ":</td><td align=left><select name=\"set_language\" size=\"1\">");
  print("<option value=\"\">" . $LangName . "</OPTION>");

  for($i=0;$i<count($LangsData);$i++)
  {
    print("<option value=\"" . $LangsData[$i]["FileName"] . "\">" . $LangsData[$i]["Name"] . "</OPTION>");
  }

  print("</select></td></tr>");
  print("<tr><td>&nbsp;</td><td align=left><input type=\"submit\" value=\"" .$Messages["Select"] . "\"></td></tr></table>");
  print("</form>");
}

// ShowUserInfo - Displays the userinfo page.
function ShowUserInfo() {
  global $Messages,$uname,$lvl,$scripturl,$nphpConfig,$version,$mydetails;
  htmlHeader($Messages["Sections_UserInfo"]);

  print("<form method=\"post\" action=\"$scripturl?userinfosave\">\n");
  print("<table border=0><tr><td align=right>");
  print($Messages["Password"] . ":</td><td align=left><input type=\"password\" name=\"set_password\"></td></tr>");
  print("<tr><td align=right>" . $Messages["Email"] . ":</td><td align=left><input type=\"text\" name=\"set_email\" value=\"" . $mydetails["email"] . "\"></td></tr>");
  print("<tr><td>&nbsp;</td><td align=left><input type=\"submit\" value=\"" .$Messages["Submit"] . "\"></td></tr></table>");
  print("</form>");

  htmlFooter();
  exit;
}

// ShowToolbar - Designs the toolbar at the bottom
function ShowToolbar() {
  global $Messages,$uname,$lvl,$scripturl,$nphpConfig,$version,$extralangs,$Extensions;
  $output = "<FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\"><A HREF=\"$scripturl\" CLASS=\"toolbar\">" . $Messages["Sections_Main"] . "</A></FONT><FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\" COLOR=\"#79A5E6\"> - </FONT>";
  $output.= "<FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\"><A HREF=\"$scripturl?submit\" CLASS=\"toolbar\">" . $Messages["Sections_SubmitNews"] . "</A></FONT><FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\" COLOR=\"#79A5E6\"> - </FONT>";
  $output.= "<FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\"><A HREF=\"$scripturl?generate\" CLASS=\"toolbar\">" . $Messages["Sections_Build"] . "</A></FONT><FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\" COLOR=\"#79A5E6\"> - </FONT>";
  $output.= "<FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\"><A HREF=\"$scripturl?remove\" CLASS=\"toolbar\">" . $Messages["Sections_Modify"] . "</A></FONT><FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\" COLOR=\"#79A5E6\"> - </FONT>";

  $output.= "<FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\"><A HREF=\"$scripturl?userinfo\" CLASS=\"toolbar\">" . $Messages["Sections_UserInfo"] . "</A></FONT><FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\" COLOR=\"#79A5E6\"> - </FONT>";

  if($lvl == 3) {
  $output.= "<FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\"><A HREF=\"$scripturl?settings\" CLASS=\"toolbar\">" . $Messages["Sections_Settings"] . "</A></FONT><FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\" COLOR=\"#79A5E6\"> - </FONT>";  
  $output.= "<FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\"><A HREF=\"$scripturl?adduser\" CLASS=\"toolbar\">" . $Messages["Sections_EditUsers"] . "</A></FONT><FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\" COLOR=\"#79A5E6\"> - </FONT>";
  }
 
  if($nphpConfig["EnableGlossary"] == 1 && $lvl == 3)
  {
  $output.= "<FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\"><A HREF=\"$scripturl?editgloss\" CLASS=\"toolbar\">" . $Messages["Sections_Gloss"] . "</A></FONT><FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\" COLOR=\"#79A5E6\"> - </FONT>";  
  }

  if($nphpConfig["NewsCategorys"] == 1 && $lvl == 3)
  {
  $output.= "<FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\"><A HREF=\"$scripturl?editcats\" CLASS=\"toolbar\">" . $Messages["Sections_Categorys"] . "</A></FONT><FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\" COLOR=\"#79A5E6\"> - </FONT>";  
  }

  if($nphpConfig["EmailUpdates"] == 1 && $lvl == 3)
  {
  $output.= "<FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\"><A HREF=\"$scripturl?email\" CLASS=\"toolbar\">" . $Messages["Email"] . "</A></FONT><FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\" COLOR=\"#79A5E6\"> - </FONT>";  
  }

  if($extralangs==1)
  {
  $output.= "<FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\"><A HREF=\"$scripturl?langs\" CLASS=\"toolbar\">" . $Messages["Sections_Language"] . "</A></FONT><FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\" COLOR=\"#79A5E6\"> - </FONT>";  
  }

  for(reset($Extensions); $i=key($Extensions); next($Extensions))
  {
   if($lvl > $Extensions[$i]["ReqLevel"]) {
    $output.= "<FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\"><A HREF=\"$scripturl?" . $Extensions[$i]["QString"] . "\" CLASS=\"toolbar\">" . $Extensions[$i]["ToolbarName"] . "</A></FONT><FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\" COLOR=\"#79A5E6\"> - </FONT>";  
   }
  }

  $output.= "<FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\"><A HREF=\"$scripturl?logout\" CLASS=\"toolbar\">" . $Messages["Sections_Logout"] . "</A></FONT>";


  if($extralangs!=1)
  {
    if($nphpConfig["SiteLink"] != "") {
    $output.= "<FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\" COLOR=\"#79A5E6\"> - </FONT><FONT FACE=\"Tahoma, Verdana\" SIZE=\"1\"><A HREF=\"" . $nphpConfig["SiteLink"] . "\" CLASS=\"toolbar\">" . $Messages["BackTo"] . " " . $nphpConfig["SiteTitle"] . "</A></FONT>";
    }
  }

  return $output;
}

// DisplayMain - Show the main page
function DisplayMain() {
  global $Messages,$uname,$lvl,$nphpConfig,$scripturl,$version,$extralangs,$Extensions;
  htmlHeader($Messages["Sections_Main"]);

  print("<table border=0 width=100% cellspacing=1 cellpadding=3>\n");
  print("<tr><td bgcolor=#D3CFCF align=right width=22% valign=top><b>" . $Messages["UserName"] . "</b></td><td><A HREF=\"mailto:" . EmailAd($uname) . "\">" . $uname . "</a></td></tr>\n");
  print("<tr><td bgcolor=#D3CFCF align=right width=22% valign=top><b><A HREF=\"$scripturl?submit\" target=\"_top\">" . $Messages["Sections_SubmitNews"] . "</A></b></td><td>" . $Messages["Mainpage_Descriptions_SubmitNews"] . "</td></tr>\n");

  If($nphpConfig["AutoBuild"] == 1)
  { $buildextra = " " . $Messages["Mainpage_Descriptions_Autobuild"]; } else { $buildextra = " " . $Messages["Mainpage_Descriptions_NoAutobuild"]; }

  print("<tr><td bgcolor=#D3CFCF align=right width=22% valign=top><b><A HREF=\"$scripturl?generate\" target=\"_top\">" . $Messages["Sections_Build"] . "</A></b></td><td>" . $Messages["Mainpage_Descriptions_Build"] . $buildextra ."</td></tr>\n");

  if($lvl == 1) {
  print("<tr><td bgcolor=#D3CFCF align=right width=22% valign=top><b><A HREF=\"$scripturl?remove\" target=\"_top\">" . $Messages["Sections_Modify"] . "</A></b></td><td>" . $Messages["Mainpage_Descriptions_Modify_1"] . "</td></tr>\n");
  } else {
  print("<tr><td bgcolor=#D3CFCF align=right width=22% valign=top><b><A HREF=\"$scripturl?remove\" target=\"_top\">" . $Messages["Sections_Modify"] . "</A></b></td><td>" . $Messages["Mainpage_Descriptions_Modify_2"] . "</td></tr>\n");
  }

  print("<tr><td bgcolor=#D3CFCF align=right width=22% valign=top><b><A HREF=\"$scripturl?userinfo\" target=\"_top\">" . $Messages["Sections_UserInfo"] . "</A></b></td><td>" . $Messages["Mainpage_Descriptions_UserInfo"] . "</td></tr>\n");

  if($lvl == 3) {
  print("<tr><td bgcolor=#D3CFCF align=right width=22% valign=top><b><A HREF=\"$scripturl?settings\" target=\"_top\">" . $Messages["Sections_Settings"] . "</A></b></td><td>" . $Messages["Mainpage_Descriptions_Settings"] . "</td></tr>\n");
  print("<tr><td bgcolor=#D3CFCF align=right width=22% valign=top><b><A HREF=\"$scripturl?adduser\" target=\"_top\">" . $Messages["Sections_EditUsers"] . "</A></b></td><td>" . $Messages["Mainpage_Descriptions_EditUsers"] . "</td></tr>\n");
  }

  if($nphpConfig["EnableGlossary"] == 1 && $lvl == 3)
  {
  print("<tr><td bgcolor=#D3CFCF align=right width=22% valign=top><b><A HREF=\"$scripturl?editgloss\" target=\"_top\">" . $Messages["Sections_Gloss"] . "</A></b></td><td>" . $Messages["Mainpage_Descriptions_Gloss"] . "</td></tr>\n");
  }

  if($nphpConfig["EmailUpdates"] == 1 && $lvl == 3)
  {
  print("<tr><td bgcolor=#D3CFCF align=right width=22% valign=top><b><A HREF=\"$scripturl?email\" target=\"_top\">" . $Messages["Email"] . "</A></b></td><td>" . $Messages["Mainpage_Descriptions_Email"] . "</td></tr>\n");
  }

  if($extralangs == 1 && $lvl == 3)
  {
  print("<tr><td bgcolor=#D3CFCF align=right width=22% valign=top><b><A HREF=\"$scripturl?langs\" target=\"_top\">" . $Messages["Sections_Language"] . "</A></b></td><td>" . $Messages["Mainpage_Descriptions_Language"] . "</td></tr>\n");
  }

  for(reset($Extensions); $i=key($Extensions); next($Extensions))
  {
   if($lvl > $Extensions[$i]["ReqLevel"]) {
  print("<tr><td bgcolor=#D3CFCF align=right width=22% valign=top><b><A HREF=\"$scripturl?" . $Extensions[$i]["QString"] . "\" target=\"_top\">" . $Extensions[$i]["ToolbarName"] . "</A></b></td><td>" . $Extensions[$i]["Description"] . "</td></tr>\n");
   }
  }

  print("<tr><td bgcolor=#D3CFCF align=right width=22% valign=top><b><A HREF=\"$scripturl?logout\" target=\"_top\">" . $Messages["Sections_Logout"] . "</A></b></td><td>" . $Messages["Mainpage_Descriptions_Logout"] . "</td></tr>\n");


  print("</table>");

  htmlFooter();
  exit;

}

// DisplaySubmit - Show the submit news page
function DisplaySubmit() {
  global $Messages,$uname,$lvl,$nphpConfig,$version,$scripturl,$SubmitFields,$nphpCats;
  htmlHeader($Messages["Sections_SubmitNews"]);

  print("<form method=\"post\" action=\"$scripturl?submitsave\">");
  print("<INPUT TYPE=\"hidden\" NAME=\"news_user\" VALUE=\"$uname\">");

  print("<TABLE WIDTH=100% CELLPADDING=4>\n");

  print("<TR><TD ALIGN=right valign=top><b>Poster:</b></TD><td>$uname</td></tr>");
  
  for($i=0; $i < count($SubmitFields); $i++)
  {
    if($SubmitFields[$i]["Type"] !=3 ) {
      if($SubmitFields[$i]["Type"] == 1) {
        print("<TR>\n<TD ALIGN=right><B>" . $SubmitFields[$i]["Description"] . ":</B></TD><TD ALIGN=left>");
        print("<INPUT TYPE=\"text\" SIZE=\"45\" NAME=\"" . $SubmitFields[$i]["Name"] . "\" VALUE=\"" . $SubmitFields[$i]["DefaultValue"] . "\">");
      } else {
        print("<TR>\n<TD ALIGN=right VALIGN=top><B>" . $SubmitFields[$i]["Description"] . ":</B></TD><TD ALIGN=left>");
        print("<TEXTAREA NAME=\"" . $SubmitFields[$i]["Name"] . "\" ROWS=\"5\" COLS=\"42\">" . $SubmitFields[$i]["DefaultValue"] . "</TEXTAREA>");
      }
      print("</TD>\n</TR>");
     } else { 
    print("<INPUT TYPE=\"hidden\" NAME=\"" . $SubmitFields[$i]["Name"] . "\" VALUE=\"" . $SubmitFields[$i]["DefaultValue"] . "\">");
    }
  }

  if($nphpConfig["NewsCategorys"] == 1)
  {
   $catdata = "<select name=category size=1>\n";   
   for($i=0; $i<count($nphpCats); $i++)
   {
     $catdata .= "<option value=\"" . $nphpCats[$i][1] . "\">" . $nphpCats[$i][0] . "</option>\n";
   }
   $catdata .= "</select>\n";
   print("<TR><TD ALIGN=right valign=top><b>" . $Messages["Category"] . ":</b></TD><td>$catdata</td></tr>");
  }

  print("<TR><TD ALIGN=right valign=top><b>" . $Messages["News"] . ":</b></TD><td><textarea rows=\"8\" cols=\"45\" name=\"NewsText\" wrap=\"virtual\"></textarea></td></tr>");

  if($nphpConfig["EnableBROption"]==1)
  {
   print("<TR><td colspan=2><center><b>" . $Messages["NLConvert"] . "</b><br><input type=\"radio\" CHECKED value=\"1\" name=\"BRConvert\" > Yes <input type=\"radio\" value=\"0\" name=\"BRConvert\"> No</center></td></tr>");
  }

  if($nphpConfig["EnableGlossary"]==1)
  {
   print("<TR><td colspan=2><center><b>" . $Messages["Enable_Gloss"] . "</b><br><input type=\"radio\" CHECKED value=\"1\" name=\"useGloss\" > Yes <input type=\"radio\" value=\"0\" name=\"useGloss\"> No</center></td></tr>");
  }

  print("<TR><TD ALIGN=right valign=top><b>&nbsp;</b></TD><td><input type=\"submit\" value=\"Post News\"></td></tr>");
  print("</TABLE>");
  htmlFooter();
  exit;

}

// Add2DataBase - Adds the new news into the database.
function Add2DataBase() {
  global $Messages,$uname,$lvl,$nphpConfig,$version,$scripturl,$SubmitFields,$nphpGlossary;

$emaildata = $nphpConfig["EmailFormat"];

  if(isset($GLOBALS["BRConvert"]))
  {  
    if($GLOBALS["BRConvert"]==1)
    {
    $news = ereg_replace("\r","",$GLOBALS["NewsText"]);
    $news = ereg_replace("\n","[BR]",$news);
    $email_newstext = $GLOBALS["NewsText"];
    } else {
    $news = ereg_replace("\n","",$GLOBALS["NewsText"]);
    $news = ereg_replace("\r","",$news);
    $email_newstext = ereg_replace("\n","",$GLOBALS["NewsText"]);
    $email_newstext = ereg_replace("\r","",$email_newstext);
    }
  }
  else
  {
    $news = ereg_replace("\n","[NL]",$GLOBALS["NewsText"]);
    $news = ereg_replace("\r","",$news);
    $email_newstext = $GLOBALS["NewsText"];
  }

 $tempdate = gmdate("H") + $nphpConfig["TimeOffset"];
 $email_timestamp = (($tempdate * 60) * 60) + gmdate("U");

 $output = gmdate("H,i,s,m,d,Y,U") . "<~>" . $uname . "<~>";
 $email_newsdate = gmdate($nphpConfig["EmailDateFormat"],$email_timestamp);
$emaildata = ereg_replace("<NewsDate>",$email_newsdate,$emaildata);

 if($nphpConfig["DisableHTML"]==1)
 {
   $news = htmlentities($news);
 } else {
   $news = $news;
 }

/*
  if($nphpConfig["AutoLinkURL"] == 1)
  {
    $tempsplit = explode($news," ");

    for($z=0;$z<count($tempsplit);$z++)
    {
      if(substr($tempsplit[$z],0,7) == "http://" || substr($tempsplit[$z],0,8) == "https://" || substr($tempsplit[$z],0,6) == "ftp://")
      {
        $url = $tempsplit[$z];
        $tempsplit[$z] = "<A HREF=\"$url\">$url</A>";
        $email_links = $url . "\n";
      }
   }

    $news="";

    for($z=0;$z<count($tempsplit);$z++)
    {
      $news.=$tempsplit[$z] . " ";
    }
  }
*/

    $tempsplit = explode($news," ");
    $email_links = "";

    for($z=0;$z<count($tempsplit);$z++)
    {
      if(substr($tempsplit[$z],0,7) == "http://" || substr($tempsplit[$z],0,8) == "https://" || substr($tempsplit[$z],0,6) == "ftp://")
      {
        $url = $tempsplit[$z];
        $email_links .= $url . "\n";
      }
   }

  if(isset($GLOBALS["useGloss"]))
  {  
    if($GLOBALS["useGloss"]==1)
    {
      for($i=0;$i<count($nphpGlossary);$i++)
      {
        $news = ereg_replace($nphpGlossary[$i][0],$nphpGlossary[$i][1],$news);
        $email_newstext = ereg_replace($nphpGlossary[$i][0],$nphpGlossary[$i][1],$email_newstext);
      }
    }
  }

  if(isset($GLOBALS["category"])) {
  $output.=$news . "<~>" . $GLOBALS["category"]; } else {
  $output.=$news . "<~>news.txt"; }

  for($i=0;$i<count($SubmitFields);$i++)
  {
   $output.="<~>" . $GLOBALS[$SubmitFields[$i]["Name"]];
   $emaildata = ereg_replace("<" . $SubmitFields[$i]["Name"] . ">",$GLOBALS[$SubmitFields[$i]["Name"]],$emaildata);
  }

//  if(!($newsdat = fopen("newsdat.txt","a")));
//  {
//     exit("Unable to open newsdat.txt for appending!");
//  }

  $newsdat = fopen("newsdat.txt","a");
  fputs($newsdat,stripslashes($output . "\n"));
  fclose($newsdat);
  
$emaildata = ereg_replace("<NewsText>",$email_newstext,$emaildata);
$emaildata = ereg_replace("<NewsPoster>",$uname,$emaildata);
$emaildata = ereg_replace("<NewsLinks>",$email_links,$emaildata);
$emaildata = ereg_replace("\[NL\]","\n",$emaildata);

  htmlHeader($Messages["SubmitNews_Saved"]);

  print($Messages["SubmitNews_SavedText"]);
 
  if($nphpConfig["AutoBuild"]) {
    BuildNewsQuick();
    EmailMailingList($emaildata);

    if($nphpConfig["EmailUpdates"]==1) {
    print(" " . $Messages["SubmitNews_SavedText_Auto"] . " " . $Messages["Email_Sent"]);
    } else {
    print(" " . $Messages["SubmitNews_SavedText_Auto"]);
    }

  } else {
    if($nphpConfig["EmailUpdates"]==1) {
    print(" " . $Messages["SubmitNews_SavedText_NoAuto"] . " " . $Messages["Email_NotSentNoBuilt"]);
    } else {
    print(" " . $Messages["SubmitNews_SavedText_NoAuto"]);
    }
  }

  htmlFooter();
  exit;
}

//EmailMailingList - Sends an email to everyone on the mailing list
function EmailMailingList($emailbody) {
  global $nphpConfig;
  $recips = file("maillist.txt");

  $sitetitle = ereg_replace("\n","",$nphpConfig["SiteTitle"]);
  $sitetitle = ereg_replace("\r","",$sitetitle);
  
  for($q=0;$q<count($recips);$q++)
  {
    $recip = ereg_replace("\n","",$recips[$q]);
    $recip = ereg_replace("\r","",$recip);
    mail($recip,stripslashes("Email from " . $sitetitle),stripslashes($emailbody) . "\n\n-------------------------------------------------------\nnewsPHP - http://sheepcow.nexen.net/","From: " . $nphpConfig["SiteTitle"] . " <" . $nphpConfig["EmailAddress"] . ">\n");
  }
}

function BuildNewsQuick() {
  global $nphpConfig,$SubmitFields,$nphpCats;
  $newsdat=file("newsdat.txt");

//  $tempfile = fopen("news.txt","w");
//  fclose($tempfile);

  for($u=0;$u<count($nphpCats); $u++)
  {
//    $tempfile = fopen($nphpCats[$u][1],"w");
//    fclose($tempfile);
    $counted[$nphpCats[$u][1]] = 0;
  }

  For($x=(count($newsdat)-1),$y=0;$x>=0;$x--,$y++)
  {
    $newssplit1 = explode("<~>",$newsdat[$x]);
    $newssplit2 = explode(",",$newssplit1[0]);

    $newsdate = date($nphpConfig["DateFormat"],$newssplit2[6]);
    $shortdate = date($nphpConfig["ShortDateFormat"],$newssplit2[6]);
    $headdate = date($nphpConfig["HeadlineDateFormat"],$newssplit2[6]);
    $newsid = "nphp" . $newssplit2[6];
    $NewsName = stripslashes($newssplit1[1]);
    $NewsText = stripslashes($newssplit1[2]);
    $NewsFile = $newssplit1[3];

    $count = 4;

    $headlines[$y]=$nphpConfig["HeadlineFormat"];

    if($nphpConfig["ShowDateOnce"]==1)
    {
      if($lastnewsday[$NewsFile] == date("z",$newssplit2[6]))
      {
        $output = $nphpConfig["NewsFormat"];
        $output = eregi_replace("<NewsDate>",$shortdate,$output);
      } else {
        $output = $nphpConfig["NewsHeadDateFormat"];
        $output = eregi_replace("<NewsDate>",$newsdate,$output);
        $output .= $nphpConfig["NewsFormat"];
        $output = eregi_replace("<NewsDate>",$shortdate,$output);
      }
    } else {
        $output = $nphpConfig["NewsFormat"];
    }

    for($i=0;$i<count($SubmitFields);$i++)
    {

     $data2insert = stripslashes(ereg_replace("\n","",$newssplit1[$count]));
     $data2insert = stripslashes(ereg_replace("\r","",$data2insert));

     if($nphpConfig["DisableHTML"]==1)
     {
      $output = eregi_replace("<" . $SubmitFields[$i]["Name"] . ">",htmlentities($data2insert),$output);
      $headlines[$y] = eregi_replace("<" . $SubmitFields[$i]["Name"] . ">",htmlentities($data2insert),$headlines[$y]);
     }
     else
     {
      $output = eregi_replace("<" . $SubmitFields[$i]["Name"] . ">",$data2insert,$output);
      $headlines[$y] = eregi_replace("<" . $SubmitFields[$i]["Name"] . ">",$data2insert,$headlines[$y]);
     }
      $count++;
    }

    if($nphpConfig["ConvertNL"]==1)
    {
//      $NewsText = htmlentities($NewsText);
      $NewsText = ereg_replace("\[NL\]","<BR>",$NewsText);
      $NewsText = ereg_replace("\[BR\]","<BR>",$NewsText);
    }


      $output = eregi_replace("<NewsText>",$NewsText,$output);
      $output = eregi_replace("<NewsName>",$NewsName,$output);
      $output = eregi_replace("<NP:ID>",$newsid,$output);
      $output = eregi_replace("<NewsDate>",$newsdate,$output);

      $headlines[$y] = eregi_replace("<NP:ID>",$newsid,$headlines[$y]);
      $headlines[$y] = eregi_replace("<NewsDate>",$headdate,$headlines[$y]);
      $headlines[$y] = eregi_replace("<NewsText>",$NewsText,$headlines[$y]);

     if($nphpConfig["Number_Limit"] <> "") { $total[$NewsFile]=$nphpConfig["Number_Limit"]; } else { $total[$NewsFile]=20; }

       if($counted[$NewsFile] > ($total[$NewsFile] -1)) { } else {
         $newsdataoutput[$NewsFile][] = $output;
//         $newsoutputfile = fopen($NewsFile,"a");
//           fputs($newsoutputfile, stripslashes($output));
//         fclose($newsoutputfile);
         $counted[$NewsFile]++;
       }

      $lastnewsday[$NewsFile] = date("z",$newssplit2[6]);
  }

    for(reset($newsdataoutput); $key = key($newsdataoutput);next($newsdataoutput))
    {
      $newsoutputfile = fopen($key,"w");
      fputs($newsoutputfile, "<!-- Generated by newsPHP -->\n");
      fputs($newsoutputfile, "<!-- http://sheepcow.nexen.net/ -->\n");

        for($e=0; $e<$total[$key]; $e++)
        { 
          fputs($newsoutputfile, stripslashes($newsdataoutput[$key][$e]));
        }

      fclose($newsoutputfile);
    }

    fputs($newsoutputfile, stripslashes($output));
  

  if($nphpConfig["DisplayLink"]==1)
  {
    for($u=0;$u<count($nphpCats); $u++)
    {
      $tempfile = fopen($nphpCats[$u][1],"a");
       fputs($tempfile,"<BR><i>news with <a href=\"http://sheepcow.nexen.net/\" target=\"_top\">newsPHP</a>.</i>\n\n");
      fclose($tempfile);
    }
  }

  if($nphpConfig["EnableHeadlines"]==1)
  {
    $headfile = fopen("headlines.txt","w");
    for($i=0;$i<$nphpConfig["HeadlineNum"];$i++)
    {
      fputs($headfile,$headlines[$i]);
    }
    fclose($headfile);
  }
}


// ReadQuery - Read the raw query string.
function ReadQuery(&$inputstring) {
  $inputstring = $GLOBALS["QUERY_STRING"];
}

// ClearCookies - Set the username and password to x, and to expire now.
function ClearCookies() {
  setcookie("uname","x",time());
  setcookie("pword","x",time());
}

// LoadConfig - Load the npconfig.php file.
function LoadConfig(&$outputarray,&$outputusers,&$outputgloss,&$outputcats) {
  $setfile = file("nconfig.php");
  $usercount = 0;
  $glosscount = 0;
  $catcount = 0;

  for($i=1;$i<count($setfile);$i++)
  {
    $splitdata = split("<~-~>",$setfile[$i],2);

    if($splitdata[0] != "userdata" && $splitdata[0] != "glossdat" && $splitdata[0] != "catdata") {
      $outputarray[$splitdata[0]] = eregi_replace("\n","",$splitdata[1]);; } else {
        if($splitdata[0] == "userdata") {

         $splituserdata = split("<~-~>",$setfile[$i],5);
         $outputusers[$usercount][0] = eregi_replace("\n","",$splituserdata[1]);
         $outputusers[$usercount][1] = eregi_replace("\n","",$splituserdata[2]);
         $outputusers[$usercount][2] = eregi_replace("\n","",$splituserdata[3]);
         $outputusers[$usercount][3] = eregi_replace("\n","",$splituserdata[4]);
         $usercount++;

        } elseif($splitdata[0] == "glossdat") {

         $splitglossdata = split("<~-~>",$setfile[$i],3);
         $outputgloss[$glosscount][0] = eregi_replace("\n","",$splitglossdata[1]);
         $outputgloss[$glosscount][0] = eregi_replace("\r","",$outputgloss[$glosscount][0]);
         $outputgloss[$glosscount][1] = eregi_replace("\n","",$splitglossdata[2]);
         $outputgloss[$glosscount][1] = eregi_replace("\r","",$outputgloss[$glosscount][1]);
         $glosscount++;
         
        } elseif($splitdata[0] == "catdata") {
         $splitcatdata = split("<~-~>",$setfile[$i],3);
         $outputcats[$catcount][0] = eregi_replace("\n","",$splitcatdata[1]);
         $outputcats[$catcount][0] = eregi_replace("\r","",$outputcats[$catcount][0]);
         $outputcats[$catcount][1] = eregi_replace("\n","",$splitcatdata[2]);
         $outputcats[$catcount][1] = eregi_replace("\r","",$outputcats[$catcount][1]);
         $catcount++;
        }
      }
    }
}

// CheckLogin - Compares the cookie and form data with the users on record.
function CheckLogin() {
  global $Messages, $scripturl, $user_name,$password,$uname,$pword,$CookieLast,$lvl;
  @LoadConfig($nphpConfig,$nphpUsers,$dump,$dump);

  if(isset($user_name))
  {
    $encpassword = md5($password);

    for($i=0; $i<count($nphpUsers); $i++)
    {
      if(stripslashes($user_name) == stripslashes($nphpUsers[$i][0]) AND $encpassword == $nphpUsers[$i][1])
      {
        setcookie("uname",$user_name,time()+$CookieLast);
        setcookie("pword",$password,time()+$CookieLast);
        $uname = $user_name;
        $pword = $password;
        $lvl = $nphpUsers[$i][3];
        $mydetails["id"] = $i;
        $mydetails["uname"] = $user_name;
        $mydetails["pword"] = $password;
        $mydetails["email"] = $nphpUsers[$i][2];
        $mydetails["lvl"] = $nphpUsers[$i][3];
        return $mydetails;
      }
    }
  } else {

    $encpassword = md5($pword);

    for($i=0; $i<count($nphpUsers); $i++)
    {
      if(stripslashes($uname) == stripslashes($nphpUsers[$i][0]) AND $encpassword == stripslashes($nphpUsers[$i][1]))
      {
        $lvl = $nphpUsers[$i][3];
        $mydetails["id"] = $i;
        $mydetails["uname"] = $uname;
        $mydetails["pword"] = $pword;
        $mydetails["email"] = $nphpUsers[$i][2];
        $mydetails["lvl"] = $nphpUsers[$i][3];
        return $mydetails;
      }

    }
  }
// Not logged in. Display login form.
ClearCookies();

htmlHeader($Messages["Login"],$Messages["Login_Description"]);
print("<form method=\"post\" action=\"$scripturl?login\">\n");
print("<table border=0><tr><td align=right>");
print($Messages["UserName"] . ":</td><td align=left><input type=\"text\" name=\"user_name\"></td></tr>");
print("<tr><td align=right>" . $Messages["Password"] . ":</td><td align=left><input type=\"password\" name=\"password\"></td></tr>");
print("<tr><td>&nbsp;</td><td align=left><input type=\"submit\" value=\"" .$Messages["Login_Login"] . "\"></td></tr></table>");
print("</form>");

if($nphpConfig["firsttime"] == 1) {
  print("\n");
  print($Messages["Login_Firsttime"]);
}
  htmlFooter();
exit;
}

function SaveNPConfig($nphpArray,$nphpUserArray,$nphpGlossArray,$nphpCatsArray) {
  $setfile = fopen("nconfig.php","w");
    fputs($setfile,"<?php print(\"This is a confidencial file. To change settings login to newsPHP.\"); exit; ?>\n");

    for(reset($nphpArray); $key=key($nphpArray); next($nphpArray))
    {
      $data2 = ereg_replace("\n","",stripslashes($nphpArray[$key]));
      $data = ereg_replace("\r","",$data2);

      fputs($setfile, "$key<~-~>" . $data . "\n");
    }
   
    for($i=0;$i<count($nphpUserArray); $i++)
    {
      $data2 = ereg_replace("\n","",stripslashes($nphpUserArray[$i][3]));
      $data = ereg_replace("\r","",$data2);
     
      if($nphpUserArray[$i][0] == "")
      {
      } else {
      fputs($setfile, "userdata<~-~>" . stripslashes($nphpUserArray[$i][0]) . "<~-~>" . stripslashes($nphpUserArray[$i][1]) . "<~-~>" . stripslashes($nphpUserArray[$i][2]) . "<~-~>" . $data . "\n");
      }
    }

    for($i=0;$i<count($nphpGlossArray); $i++)
    {
      $data2 = ereg_replace("\n","",$nphpGlossArray[$i][1]);
      $data = ereg_replace("\r","",$data2);
      if($nphpGlossArray[$i][0] != "" AND $nphpGlossArray[$i][1] != "") {
        fputs($setfile, "glossdat<~-~>" . stripslashes($nphpGlossArray[$i][0]) . "<~-~>" . stripslashes($data) . "\n");
      }
    }

    for($i=0;$i<count($nphpCatsArray); $i++)
    {
      $data2 = ereg_replace("\n","",$nphpCatsArray[$i][1]);
      $data = ereg_replace("\r","",$data2);
      if($nphpCatsArray[$i][0] != "" AND $nphpCatsArray[$i][1] != "") {
        fputs($setfile, "catdata<~-~>" . stripslashes($nphpCatsArray[$i][0]) . "<~-~>" . stripslashes($data) . "\n");
      }
    }

  fclose($setfile);
}

function EmailAd($username) {
  LoadConfig($dump,$data,$dump,$dump);

  for($i=0;$i<count($data);$i++)
  {
    If($data[$i][0] == $username)
      return $data[$i][2];
  }
}

function NextField()
{
  return count($GLOBALS["SubmitFields"]);
}
?>